CreateAgentRuntime
Creates an Amazon Bedrock AgentCore Runtime.
Request Syntax
PUT /runtimes/ HTTP/1.1
Content-type: application/json
{
"agentRuntimeArtifact": { ... },
"agentRuntimeName": "string",
"allowedPorts": [
{ ... }
],
"authorizerConfiguration": { ... },
"capacityProviderConfiguration": {
"capacityProviderArn": "string"
},
"clientToken": "string",
"description": "string",
"environmentVariables": {
"string" : "string"
},
"filesystemConfigurations": [
{ ... }
],
"hooksConfiguration": {
"build": {
"warmup": {
"action": { ... }
}
}
},
"lifecycleConfiguration": {
"idleRuntimeSessionTimeout": number,
"maxLifetime": number
},
"networkConfiguration": {
"networkMode": "string",
"networkModeConfig": {
"requireServiceS3Endpoint": boolean,
"securityGroups": [ "string" ],
"subnets": [ "string" ]
}
},
"platformVersion": "string",
"protocolConfiguration": {
"path": "string",
"port": number,
"serverProtocol": "string"
},
"requestHeaderConfiguration": { ... },
"resourceConfigurations": [
{
"minimumMemoryInMiB": number
}
],
"roleArn": "string",
"tags": {
"string" : "string"
}
}
URI Request Parameters
The request does not use any URI parameters.
Request Body
The request accepts the following data in JSON format.
- agentRuntimeArtifact
-
The artifact of the AgentCore Runtime.
Type: AgentRuntimeArtifact object
Note: This object is a Union. Only one member of this object can be specified or returned.
Required: Yes
- agentRuntimeName
-
The name of the AgentCore Runtime.
Type: String
Pattern:
[a-zA-Z][a-zA-Z0-9_]{0,47}Required: Yes
- allowedPorts
-
The additional ports on the AgentCore Runtime that are reachable through the runtime's session URL. Specify one to five non-overlapping entries, each containing either a single port or an inclusive port range. Ports must be between
8000and12000, excluding the reserved port8443.Type: Array of AllowedPort objects
Array Members: Minimum number of 1 item. Maximum number of 5 items.
Required: No
-
The authorizer configuration for the AgentCore Runtime.
Type: AuthorizerConfiguration object
Note: This object is a Union. Only one member of this object can be specified or returned.
Required: No
- capacityProviderConfiguration
-
The capacity provider configuration for the AgentCore Runtime. Use a capacity provider to run the AgentCore Runtime on the Instances compute type, which provisions AWS managed compute in your account.
Type: CapacityProviderConfiguration object
Required: No
- clientToken
-
A unique, case-sensitive identifier to ensure idempotency of the request.
Type: String
Length Constraints: Minimum length of 33. Maximum length of 256.
Pattern:
[a-zA-Z0-9](-*[a-zA-Z0-9]){0,256}Required: No
- description
-
The description of the AgentCore Runtime.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 4096.
Required: No
- environmentVariables
-
Environment variables to set in the AgentCore Runtime environment.
Type: String to string map
Map Entries: Minimum number of 0 items. Maximum number of 50 items.
Key Length Constraints: Minimum length of 1. Maximum length of 100.
Value Length Constraints: Minimum length of 0. Maximum length of 5000.
Required: No
- filesystemConfigurations
-
The filesystem configurations to mount into the AgentCore Runtime. Use filesystem configurations to provide persistent storage to your AgentCore Runtime sessions.
Type: Array of FilesystemConfiguration objects
Array Members: Minimum number of 0 items. Maximum number of 5 items.
Required: No
- hooksConfiguration
-
The lifecycle hooks configuration for the AgentCore Runtime. Use lifecycle hooks to run actions in the agent's container at fixed points in the runtime's lifecycle, such as warming up the agent before sessions are created.
Type: RuntimeHooksConfiguration object
Required: No
- lifecycleConfiguration
-
The life cycle configuration for the AgentCore Runtime.
Type: LifecycleConfiguration object
Required: No
- networkConfiguration
-
The network configuration for the AgentCore Runtime.
Type: NetworkConfiguration object
Required: No
- platformVersion
-
The version of the runtime platform to use for the AgentCore Runtime.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 128.
Pattern:
[^\s]+Required: No
- protocolConfiguration
-
The protocol configuration for the AgentCore Runtime, including the protocol, port, and path on which the agent server is available.
Type: ProtocolConfiguration object
Required: No
- requestHeaderConfiguration
-
Configuration for HTTP request headers that will be passed through to the runtime.
Type: RequestHeaderConfiguration object
Note: This object is a Union. Only one member of this object can be specified or returned.
Required: No
- resourceConfigurations
-
The resource configurations for the AgentCore Runtime, such as the minimum amount of memory to allocate to the runtime. You can specify at most one resource configuration.
Type: Array of ResourceConfiguration objects
Array Members: Minimum number of 0 items. Maximum number of 1 item.
Required: No
- roleArn
-
The IAM role ARN that provides permissions for the AgentCore Runtime.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 2048.
Pattern:
arn:aws(-[^:]+)?:iam::([0-9]{12})?:role/.+Required: Yes
-
A map of tag keys and values to assign to the agent runtime. Tags enable you to categorize your resources in different ways, for example, by purpose, owner, or environment.
Type: String to string map
Map Entries: Minimum number of 0 items. Maximum number of 50 items.
Key Length Constraints: Minimum length of 1. Maximum length of 128.
Key Pattern:
[a-zA-Z0-9\s._:/=+@-]*Value Length Constraints: Minimum length of 0. Maximum length of 256.
Value Pattern:
[a-zA-Z0-9\s._:/=+@-]*Required: No
Response Syntax
HTTP/1.1 202
Content-type: application/json
{
"agentRuntimeArn": "string",
"agentRuntimeId": "string",
"agentRuntimeVersion": "string",
"createdAt": "string",
"status": "string",
"workloadIdentityDetails": {
"workloadIdentityArn": "string"
}
}
Response Elements
If the action is successful, the service sends back an HTTP 202 response.
The following data is returned in JSON format by the service.
- agentRuntimeArn
-
The Amazon Resource Name (ARN) of the AgentCore Runtime.
Type: String
Pattern:
arn:aws(-[^:]+)?:bedrock-agentcore:[a-z0-9-]+:[0-9]{12}:runtime/[a-zA-Z][a-zA-Z0-9_]{0,47}-[a-zA-Z0-9]{10} - agentRuntimeId
-
The unique identifier of the AgentCore Runtime.
Type: String
Pattern:
[a-zA-Z][a-zA-Z0-9_]{0,99}-[a-zA-Z0-9]{10} - agentRuntimeVersion
-
The version of the AgentCore Runtime.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 5.
Pattern:
([1-9][0-9]{0,4}) - createdAt
-
The timestamp when the AgentCore Runtime was created.
Type: Timestamp
- status
-
The current status of the AgentCore Runtime.
Type: String
Valid Values:
CREATING | CREATE_FAILED | UPDATING | UPDATE_FAILED | READY | DELETING | DELETE_FAILED - workloadIdentityDetails
-
The workload identity details for the AgentCore Runtime.
Type: WorkloadIdentityDetails object
Errors
For information about the errors that are common to all actions, see Common Error Types.
- AccessDeniedException
-
This exception is thrown when a request is denied per access permissions
HTTP Status Code: 403
- ConflictException
-
This exception is thrown when there is a conflict performing an operation
HTTP Status Code: 409
- InternalServerException
-
This exception is thrown if there was an unexpected error during processing of request
HTTP Status Code: 500
- ServiceQuotaExceededException
-
This exception is thrown when a request is made beyond the service quota
HTTP Status Code: 402
- ThrottlingException
-
This exception is thrown when the number of requests exceeds the limit
HTTP Status Code: 429
- ValidationException
-
The input fails to satisfy the constraints specified by the service.
HTTP Status Code: 400
See Also
For more information about using this API in one of the language-specific AWS SDKs, see the following: